import _extends from "@babel/runtime/helpers/esm/extends";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";

function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return exports; }; var exports = {}, Op = Object.prototype, hasOwn = Op.hasOwnProperty, $Symbol = "function" == typeof Symbol ? Symbol : {}, iteratorSymbol = $Symbol.iterator || "@@iterator", asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator", toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag"; function define(obj, key, value) { return Object.defineProperty(obj, key, { value: value, enumerable: !0, configurable: !0, writable: !0 }), obj[key]; } try { define({}, ""); } catch (err) { define = function define(obj, key, value) { return obj[key] = value; }; } function wrap(innerFn, outerFn, self, tryLocsList) { var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator, generator = Object.create(protoGenerator.prototype), context = new Context(tryLocsList || []); return generator._invoke = function (innerFn, self, context) { var state = "suspendedStart"; return function (method, arg) { if ("executing" === state) throw new Error("Generator is already running"); if ("completed" === state) { if ("throw" === method) throw arg; return doneResult(); } for (context.method = method, context.arg = arg;;) { var delegate = context.delegate; if (delegate) { var delegateResult = maybeInvokeDelegate(delegate, context); if (delegateResult) { if (delegateResult === ContinueSentinel) continue; return delegateResult; } } if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) { if ("suspendedStart" === state) throw state = "completed", context.arg; context.dispatchException(context.arg); } else "return" === context.method && context.abrupt("return", context.arg); state = "executing"; var record = tryCatch(innerFn, self, context); if ("normal" === record.type) { if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue; return { value: record.arg, done: context.done }; } "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg); } }; }(innerFn, self, context), generator; } function tryCatch(fn, obj, arg) { try { return { type: "normal", arg: fn.call(obj, arg) }; } catch (err) { return { type: "throw", arg: err }; } } exports.wrap = wrap; var ContinueSentinel = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var IteratorPrototype = {}; define(IteratorPrototype, iteratorSymbol, function () { return this; }); var getProto = Object.getPrototypeOf, NativeIteratorPrototype = getProto && getProto(getProto(values([]))); NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype); var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype); function defineIteratorMethods(prototype) { ["next", "throw", "return"].forEach(function (method) { define(prototype, method, function (arg) { return this._invoke(method, arg); }); }); } function AsyncIterator(generator, PromiseImpl) { function invoke(method, arg, resolve, reject) { var record = tryCatch(generator[method], generator, arg); if ("throw" !== record.type) { var result = record.arg, value = result.value; return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) { invoke("next", value, resolve, reject); }, function (err) { invoke("throw", err, resolve, reject); }) : PromiseImpl.resolve(value).then(function (unwrapped) { result.value = unwrapped, resolve(result); }, function (error) { return invoke("throw", error, resolve, reject); }); } reject(record.arg); } var previousPromise; this._invoke = function (method, arg) { function callInvokeWithMethodAndArg() { return new PromiseImpl(function (resolve, reject) { invoke(method, arg, resolve, reject); }); } return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); }; } function maybeInvokeDelegate(delegate, context) { var method = delegate.iterator[context.method]; if (undefined === method) { if (context.delegate = null, "throw" === context.method) { if (delegate.iterator["return"] && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel; context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method"); } return ContinueSentinel; } var record = tryCatch(method, delegate.iterator, context.arg); if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel; var info = record.arg; return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel); } function pushTryEntry(locs) { var entry = { tryLoc: locs[0] }; 1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry); } function resetTryEntry(entry) { var record = entry.completion || {}; record.type = "normal", delete record.arg, entry.completion = record; } function Context(tryLocsList) { this.tryEntries = [{ tryLoc: "root" }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0); } function values(iterable) { if (iterable) { var iteratorMethod = iterable[iteratorSymbol]; if (iteratorMethod) return iteratorMethod.call(iterable); if ("function" == typeof iterable.next) return iterable; if (!isNaN(iterable.length)) { var i = -1, next = function next() { for (; ++i < iterable.length;) { if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next; } return next.value = undefined, next.done = !0, next; }; return next.next = next; } } return { next: doneResult }; } function doneResult() { return { value: undefined, done: !0 }; } return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) { var ctor = "function" == typeof genFun && genFun.constructor; return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name)); }, exports.mark = function (genFun) { return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun; }, exports.awrap = function (arg) { return { __await: arg }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () { return this; }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) { void 0 === PromiseImpl && (PromiseImpl = Promise); var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl); return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) { return result.done ? result.value : iter.next(); }); }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () { return this; }), define(Gp, "toString", function () { return "[object Generator]"; }), exports.keys = function (object) { var keys = []; for (var key in object) { keys.push(key); } return keys.reverse(), function next() { for (; keys.length;) { var key = keys.pop(); if (key in object) return next.value = key, next.done = !1, next; } return next.done = !0, next; }; }, exports.values = values, Context.prototype = { constructor: Context, reset: function reset(skipTempReset) { if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) { "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined); } }, stop: function stop() { this.done = !0; var rootRecord = this.tryEntries[0].completion; if ("throw" === rootRecord.type) throw rootRecord.arg; return this.rval; }, dispatchException: function dispatchException(exception) { if (this.done) throw exception; var context = this; function handle(loc, caught) { return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught; } for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i], record = entry.completion; if ("root" === entry.tryLoc) return handle("end"); if (entry.tryLoc <= this.prev) { var hasCatch = hasOwn.call(entry, "catchLoc"), hasFinally = hasOwn.call(entry, "finallyLoc"); if (hasCatch && hasFinally) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } else if (hasCatch) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); } else { if (!hasFinally) throw new Error("try statement without catch or finally"); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } } } }, abrupt: function abrupt(type, arg) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) { var finallyEntry = entry; break; } } finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null); var record = finallyEntry ? finallyEntry.completion : {}; return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record); }, complete: function complete(record, afterLoc) { if ("throw" === record.type) throw record.arg; return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel; }, finish: function finish(finallyLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel; } }, "catch": function _catch(tryLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc === tryLoc) { var record = entry.completion; if ("throw" === record.type) { var thrown = record.arg; resetTryEntry(entry); } return thrown; } } throw new Error("illegal catch attempt"); }, delegateYield: function delegateYield(iterable, resultName, nextLoc) { return this.delegate = { iterator: values(iterable), resultName: resultName, nextLoc: nextLoc }, "next" === this.method && (this.arg = undefined), ContinueSentinel; } }, exports; }

import partial from 'lodash.partial';
import { initDomain } from '@resolve-js/core';
import { createQueryExecutor, eventSubscriberFactory } from '@resolve-js/runtime-base';
import { getSecretsManager } from '../../runtime/get-secrets-manager';
import { getEventStore } from '../../runtime/get-event-store';
import { getSagaRuntime } from '../../runtime/get-saga-runtime';
import { mockSideEffects } from '../../runtime/mock-side-effects';
import { getReadModelAdapter } from '../../runtime/get-read-model-adapter';
import { defaultAssertion } from '../../utils/assertions';
import { getCommandImplementationKey, getQueryImplementationKey } from '../../runtime/utils';

var promisedAssertion = function promisedAssertion(assertion, result, error) {
  return new Promise(function (resolve, reject) {
    return assertion(resolve, reject, result, error, false);
  });
};

export var makeTestEnvironment = function makeTestEnvironment(context) {
  var mockedCommandImplementations = new Map();
  var mockedQueryImplementations = new Map();
  var executed = false;
  var useRealSideEffects = false;
  var sideEffectsStartTimestamp = 0;
  var assertions = [];
  var secretsManager = getSecretsManager();
  var completeTest;
  var failTest;

  var setSecretsManager = function setSecretsManager(value) {
    secretsManager = value;
  };

  var allowSideEffects = function allowSideEffects() {
    useRealSideEffects = true;
  };

  var setSideEffectsStartTimestamp = function setSideEffectsStartTimestamp(value) {
    sideEffectsStartTimestamp = value;
  };

  var addAssertion = function addAssertion(value) {
    assertions.push(partial(promisedAssertion, value));
  };

  var isExecuted = function isExecuted() {
    return executed;
  };

  var mockCommandImplementation = function mockCommandImplementation(aggregateName, type, implementation) {
    mockedCommandImplementations.set(getCommandImplementationKey({
      type: type,
      aggregateName: aggregateName
    }), implementation);
  };

  var mockQueryImplementation = function mockQueryImplementation(modelName, resolverName, implementation) {
    mockedQueryImplementations.set(getQueryImplementationKey({
      modelName: modelName,
      resolverName: resolverName
    }), implementation);
  };

  var promise = new Promise(function (resolve, reject) {
    completeTest = resolve;
    failTest = reject;
  });

  var execute = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3() {
      var result, saga, events, adapter, encryption, actualEncryption, actualAdapter, isNext, domain, liveErrors, monitoring, errors, eventSubscriber, executor, eventstoreAdapter, runtime, res, status, liveErrorIndex, _error2, summaryError;

      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              executed = true;
              result = {
                commands: [],
                scheduledCommands: [],
                queries: [],
                sideEffects: []
              };
              saga = context.saga, events = context.events, adapter = context.adapter, encryption = context.encryption;
              actualEncryption = encryption != null ? encryption : /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
                return _regeneratorRuntime().wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        return _context.abrupt("return", null);

                      case 1:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              if (!(adapter != null)) {
                _context3.next = 8;
                break;
              }

              _context3.t0 = adapter;
              _context3.next = 11;
              break;

            case 8:
              _context3.next = 10;
              return getReadModelAdapter();

            case 10:
              _context3.t0 = _context3.sent;

            case 11:
              actualAdapter = _context3.t0;
              isNext = false;
              domain = initDomain({
                viewModels: [],
                readModels: [],
                aggregates: [],
                sagas: [{
                  name: saga.name,
                  handlers: saga.handlers,
                  sideEffects: useRealSideEffects ? saga.sideEffects : mockSideEffects(result, saga.sideEffects),
                  connectorName: 'ADAPTER_NAME',
                  encryption: actualEncryption
                }],
                apiHandlers: []
              });
              liveErrors = [];
              monitoring = {
                group: function group(config) {
                  if (config.Part !== 'ReadModelProjection') {
                    return monitoring;
                  }

                  return _extends({}, monitoring, {
                    error: function (_error) {
                      function error(_x) {
                        return _error.apply(this, arguments);
                      }

                      error.toString = function () {
                        return _error.toString();
                      };

                      return error;
                    }(function (error) {
                      liveErrors.push(error);
                    }),
                    execution: function execution(error) {
                      if (error != null) {
                        liveErrors.push(error);
                      }
                    }
                  });
                },
                time: function time() {
                  return void 0;
                },
                timeEnd: function timeEnd() {
                  return void 0;
                },
                error: function error() {
                  return void 0;
                },
                execution: function execution() {
                  return void 0;
                },
                publish: function () {
                  var _publish = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
                    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            return _context2.abrupt("return", void 0);

                          case 1:
                          case "end":
                            return _context2.stop();
                        }
                      }
                    }, _callee2);
                  }));

                  function publish() {
                    return _publish.apply(this, arguments);
                  }

                  return publish;
                }(),
                duration: function duration() {
                  return void 0;
                },
                custom: function custom() {
                  return void 0;
                },
                rate: function rate() {
                  return void 0;
                },
                getMetrics: function getMetrics() {
                  return {
                    metrics: []
                  };
                },
                clearMetrics: function clearMetrics() {
                  return void 0;
                }
              };
              errors = [];
              eventSubscriber = null;
              executor = null;
              _context3.prev = 19;
              _context3.next = 22;
              return getEventStore(events);

            case 22:
              eventstoreAdapter = _context3.sent;
              runtime = getSagaRuntime(result, {
                commands: mockedCommandImplementations,
                queries: mockedQueryImplementations
              }, domain.sagaDomain.schedulerName, secretsManager, monitoring, sideEffectsStartTimestamp);
              eventSubscriber = eventSubscriberFactory({
                getEventSubscriberDestination: function getEventSubscriberDestination() {
                  return 'LOCAL';
                },
                applicationName: 'APP_NAME',
                readModelConnectors: {
                  ADAPTER_NAME: actualAdapter
                },
                getVacantTimeInMillis: function getVacantTimeInMillis() {
                  return 0x7fffffff;
                },
                eventstoreAdapter: eventstoreAdapter,
                readModelsInterop: {},
                performanceTracer: null,
                loadReadModelProcedure: function loadReadModelProcedure() {
                  return Promise.resolve(null);
                },
                setCurrentEventSubscriber: function setCurrentEventSubscriber() {
                  return void 0;
                },
                sagasInterop: domain.sagaDomain.acquireSagasInterop(runtime),
                monitoring: null
              });
              executor = createQueryExecutor({
                readModelConnectors: {
                  ADAPTER_NAME: actualAdapter
                },
                readModelsInterop: domain.sagaDomain.acquireSagasInterop(runtime),
                viewModelsInterop: {},
                performanceTracer: null,
                monitoring: null,
                eventSubscriber: eventSubscriber
              });
              _context3.prev = 26;
              _context3.next = 29;
              return executor.subscribe({
                modelName: saga.name,
                subscriptionOptions: {
                  eventTypes: null,
                  aggregateIds: null
                }
              });

            case 29:
              _context3.next = 31;
              return executor.resume({
                modelName: saga.name
              });

            case 31:
              isNext = false; // TODO ???

              _context3.next = 34;
              return executor.build({
                modelName: saga.name
              });

            case 34:
              res = _context3.sent;

              if (res.payload["continue"]) {
                isNext = true;
              }

            case 36:
              if (isNext) {
                _context3.next = 31;
                break;
              }

            case 37:
              _context3.next = 39;
              return executor.status({
                modelName: saga.name
              });

            case 39:
              status = _context3.sent;

              if (!(status.status === 'error')) {
                _context3.next = 51;
                break;
              }

              if (Array.isArray(status.errors)) {
                _context3.next = 43;
                break;
              }

              throw new Error('Unknown error');

            case 43:
              liveErrorIndex = status.errors.length === 1 ? liveErrors.findIndex(function (err) {
                return err.message === status.errors[0].message;
              }) : -1;

              if (!(liveErrorIndex < 0)) {
                _context3.next = 50;
                break;
              }

              _error2 = new Error(status.errors.map(function (err) {
                return err.message;
              }).join('\n'));
              _error2.stack = status.errors.map(function (err) {
                return err.stack;
              }).join('\n');
              throw _error2;

            case 50:
              throw liveErrors[liveErrorIndex];

            case 51:
              _context3.next = 56;
              break;

            case 53:
              _context3.prev = 53;
              _context3.t1 = _context3["catch"](26);
              errors.push(_context3.t1);

            case 56:
              _context3.prev = 56;
              _context3.next = 59;
              return executor.unsubscribe({
                modelName: saga.name
              });

            case 59:
              _context3.next = 64;
              break;

            case 61:
              _context3.prev = 61;
              _context3.t2 = _context3["catch"](56);
              errors.push(_context3.t2);

            case 64:
              _context3.next = 69;
              break;

            case 66:
              _context3.prev = 66;
              _context3.t3 = _context3["catch"](19);
              errors.push(_context3.t3);

            case 69:
              if (!(errors.length === 0)) {
                _context3.next = 85;
                break;
              }

              if (!(assertions.length > 0)) {
                _context3.next = 82;
                break;
              }

              _context3.prev = 71;
              _context3.next = 74;
              return Promise.all(assertions.map(function (assertion) {
                return assertion(result, null);
              }));

            case 74:
              completeTest(result);
              _context3.next = 80;
              break;

            case 77:
              _context3.prev = 77;
              _context3.t4 = _context3["catch"](71);
              failTest(_context3.t4);

            case 80:
              _context3.next = 83;
              break;

            case 82:
              defaultAssertion(completeTest, failTest, result, null);

            case 83:
              _context3.next = 101;
              break;

            case 85:
              summaryError = errors[0];

              if (errors.length > 1) {
                summaryError = new Error(errors.map(function (err) {
                  return err.message;
                }).join('\n'));
                summaryError.stack = errors.map(function (err) {
                  return err.stack;
                }).join('\n');
              } // eslint-disable-next-line no-console


              console.error(summaryError);

              if (!(assertions.length > 0)) {
                _context3.next = 100;
                break;
              }

              _context3.prev = 89;
              _context3.next = 92;
              return Promise.all(assertions.map(function (assertion) {
                return assertion(result, errors[0]);
              }));

            case 92:
              failTest(errors[0]);
              _context3.next = 98;
              break;

            case 95:
              _context3.prev = 95;
              _context3.t5 = _context3["catch"](89);
              failTest(_context3.t5);

            case 98:
              _context3.next = 101;
              break;

            case 100:
              defaultAssertion(completeTest, failTest, result, errors[0]);

            case 101:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, null, [[19, 66], [26, 53], [56, 61], [71, 77], [89, 95]]);
    }));

    return function execute() {
      return _ref.apply(this, arguments);
    };
  }();

  setImmediate(execute);
  return {
    setSecretsManager: setSecretsManager,
    allowSideEffects: allowSideEffects,
    setSideEffectsStartTimestamp: setSideEffectsStartTimestamp,
    addAssertion: addAssertion,
    isExecuted: isExecuted,
    promise: promise,
    mockCommandImplementation: mockCommandImplementation,
    mockQueryImplementation: mockQueryImplementation
  };
};
//# sourceMappingURL=make-test-environment.js.map